<?php
/*
 * Template Name: Author
 * Description: A Page Template with a Page Builder design.
 */
     $fredia_redux_demo = get_option('redux_demo');
     get_header(); 
?>
<?php if(isset($fredia_redux_demo['blog_image']['url']) && $fredia_redux_demo['blog_image']['url'] != ''){?>
<div class="ready banner-padding bg-img bg-fixed valign" data-background="<?php echo esc_url($fredia_redux_demo['blog_image']['url']);?>">
<?php }else{?>
<div class="ready banner-padding bg-img bg-fixed valign" data-background="<?php echo get_template_directory_uri();?>/images/slider/05.jpg">
<?php } ?>
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <div class="text-right">
                    <div class="title mt-60 animate-box" data-animate-effect="fadeInUp">
                        <h1 class="mb-0"><?php the_post(); 
                         printf( esc_html__( 'All posts by %s', 'fredia' ), get_the_author() );?></h1> 
                        <h6><?php if(isset($fredia_redux_demo['blog_subtitle'])){?>
                <?php echo esc_attr($fredia_redux_demo['blog_subtitle']);?>
                <?php }else{?>
                <?php echo esc_html__( 'The latest news', 'fredia' ); } ?></h6>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- Blog Content & Sidebar -->
<section id="blog" class="fredia-blog-section blog-page section-padding">
    <div class="container">
        <div class="row">
            <div class="col-md-8 animate-box" data-animate-effect="fadeInUp">
                <div class="row">

                    <?php 
                    $args = array(    
                        'paged' => $paged,
                        'post_type' => 'post',
                        'order'   => 'ASC'
                        );
                    $wp_query = new WP_Query($args);
                        while (have_posts()): the_post(); 
                            
                        $image_blog = get_post_meta(get_the_ID(),'_cmb_image_blog', true);
                        $subtitle = get_post_meta(get_the_ID(),'_cmb_subtitle', true);
                    ?>
                    <div class="col-md-12">
                        <div class="item">
                            <div class="post-img">
                                <a href="<?php the_permalink();?>"> <img src="<?php echo wp_get_attachment_url($image_blog);?>" alt=""> </a>
                            </div>
                            <div class="post-cont"> <a href="<?php the_permalink();?>"><span class="tag"><?php echo esc_attr($subtitle);?></span></a>
                                <h5>
                            <a href="<?php the_permalink();?>"><?php the_title(); ?></a>
                        </h5>
                                <p><?php if(isset($fredia_redux_demo['blog_excerpt'])){?>
                                <?php echo esc_attr(fredia_excerpt($fredia_redux_demo['blog_excerpt'])); ?>
                                <?php }else{?>
                                <?php echo esc_attr(fredia_excerpt(50)); } ?></p>
                                <div class="info"><?php the_time(get_option( 'date_format' ));?></div>
                            </div>
                        </div>
                    </div>
                    <?php endwhile; ?>
                    
                </div>
                <div class="row">
                    <div class="col-md-12 text-center">
                        <!-- Pagination -->
                        <?php 
                        $pagination = array(
                        'base'      => str_replace( 999999999, '%#%', get_pagenum_link( 999999999 ) ),
                        'format'    => '',
                        'prev_text' => wp_specialchars_decode(esc_html__( '<i class="ti-arrow-left"></i>', 'fredia' ),ENT_QUOTES),
                        'next_text' => wp_specialchars_decode(esc_html__( '<i class="ti-arrow-right"></i>', 'fredia' ),ENT_QUOTES),
                        'type'      => 'list',
                        'end_size'    => 3,
                        'mid_size'    => 3
                        );
                        if(paginate_links( $pagination ) != ''){
                            $return =  paginate_links( $pagination );
                            echo str_replace( "<ul class='page-numbers'>", '<ul class="blog-pagination-wrap align-center">', $return );
                        }
                        ?>
                    </div>
                </div>
            </div>
            <div class="col-md-4 animate-box" data-animate-effect="fadeInUp">
                <div class="blog-sidebar row">
                    <?php get_sidebar();?> 
                </div>
            </div>
        </div>
    </div>
</section>
<?php
    get_footer();
?>