<?php
$fredia_redux_demo = get_option('redux_demo');

//Custom fields:
require_once get_template_directory() . '/framework/wp_bootstrap_navwalker.php';
require_once get_template_directory() . '/framework/widget/recent-post.php';
require_once get_template_directory() . '/framework/class-ocdi-importer.php';
//Theme Set up:
function fredia_theme_setup() {
    /*
     * This theme uses a custom image size for featured images, displayed on
     * "standard" posts and pages.
     */
  	add_theme_support( 'custom-header' ); 
  	add_theme_support( 'custom-background' );
    remove_filter('the_content', 'wpautop');
  	$lang = get_template_directory_uri() . '/languages';
    load_theme_textdomain('fredia', $lang);
    add_theme_support( 'post-thumbnails' );
    // Adds RSS feed links to <head> for posts and comments.
    add_theme_support( 'automatic-feed-links' );
    // Switches default core markup for search form, comment form, and comments
    // to output valid HTML5.
    add_theme_support( "title-tag" );
    add_theme_support( 'html5', array( 'search-form', 'comment-form', 'comment-list' ) );
    // This theme uses wp_nav_menu() in one location.
  	register_nav_menus( array(
      'primary' =>  esc_html__( 'Primary Navigation Menu: Chosen menu in  pages ...', 'fredia' ),
      'primary_black' =>  esc_html__( 'Primary Black Navigation Menu: Chosen menu in  pages ...', 'fredia' ),
  	) );
      // This theme uses its own gallery styles.
}
add_action( 'after_setup_theme', 'fredia_theme_setup' );
if ( ! isset( $content_width ) ) $content_width = 900;
function fredia_theme_scripts_styles() {
  	$fredia_redux_demo = get_option('redux_demo');
  	$protocol = is_ssl() ? 'https' : 'http';
    wp_enqueue_style( 'bootstrap', get_template_directory_uri().'/css/bootstrap.min.css');
    wp_enqueue_style( 'animate', get_template_directory_uri().'/css/animate.css');
    wp_enqueue_style( 'themify-icons', get_template_directory_uri().'/css/themify-icons.css');
    wp_enqueue_style( 'flaticon', get_template_directory_uri().'/css/flaticon.css');
    wp_enqueue_style( 'owl-carousel', get_template_directory_uri().'/modules/owl-carousel/owl.carousel.min.css');
    wp_enqueue_style( 'owl-theme-default', get_template_directory_uri().'/modules/owl-carousel/owl.theme.default.min.css');
    wp_enqueue_style( 'magnific-popup', get_template_directory_uri().'/modules/magnific-popup/magnific-popup.css');
    wp_enqueue_style( 'swiper', get_template_directory_uri().'/modules/swiper/swiper.min.css');
    if (!is_page_template( 'page-templates/home-page-black.php' ) || !is_page_template( 'page-templates/about-black.php' )|| !is_page_template( 'page-templates/services-black.php' ) || !is_page_template( 'page-templates/gallery-black.php' ) || !is_page_template( 'page-templates/blog-black.php' ) || !is_page_template( 'page-templates/contact-black.php' ) ) {
    wp_enqueue_style( 'fredia-css', get_template_directory_uri().'/css/style.css');
     }
    if ( is_page_template( 'page-templates/home-page-black.php' ) || is_page_template( 'page-templates/about-black.php' ) || is_page_template( 'page-templates/services-black.php' ) || is_page_template( 'page-templates/gallery-black.php' ) || is_page_template( 'page-templates/blog-black.php' )  || is_page_template( 'page-templates/contact-black.php' ) ) {
    wp_enqueue_style( 'fredia-css-black', get_template_directory_uri().'/css/style-black.css');
     }
    wp_enqueue_style( 'fredia-style', get_stylesheet_uri(), array(), '2021-09-01' );

    if(isset($fredia_redux_demo['rtl']) && $fredia_redux_demo['rtl']==1){
    wp_enqueue_style( 'rtl', get_template_directory_uri().'/rtl.css');  }

  	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) )
    wp_enqueue_script( 'comment-reply' );
    //Javascript
    wp_enqueue_script('jquery-3.5.1', get_template_directory_uri().'/js/plugins/jquery-3.5.1.min.js',array(),false,true);
    wp_enqueue_script('bootstrap', get_template_directory_uri().'/js/plugins/bootstrap.min.js',array(),false,true);
    wp_enqueue_script('imagesloaded-pkgd', get_template_directory_uri().'/js/plugins/imagesloaded.pkgd.min.js',array(),false,true);
    wp_enqueue_script('jquery-isotope', get_template_directory_uri().'/js/plugins/jquery.isotope.v3.0.2.js',array(),false,true);
    wp_enqueue_script('modernizr-2.6.2', get_template_directory_uri().'/js/plugins/modernizr-2.6.2.min.js',array(),false,true);
    wp_enqueue_script('jquery-waypoints', get_template_directory_uri().'/js/plugins/jquery.waypoints.min.js',array(),false,true);
    wp_enqueue_script('owl-carousel', get_template_directory_uri().'/modules/owl-carousel/owl.carousel.min.js',array(),false,true);
    wp_enqueue_script('swiper', get_template_directory_uri().'/modules/swiper/swiper.min.js',array(),false,true);
    wp_enqueue_script('magnific-popup', get_template_directory_uri().'/modules/magnific-popup/jquery.magnific-popup.js',array(),false,true);
    wp_enqueue_script('masonry-pkgd', get_template_directory_uri().'/modules/masonry/masonry.pkgd.min.js',array(),false,true);
    wp_enqueue_script('fredia-script', get_template_directory_uri().'/js/script.js',array(),false,true);
}
add_action( 'wp_enqueue_scripts', 'fredia_theme_scripts_styles' );
//Custom Excerpt Function
function fredia_do_shortcode($content) {
    global $shortcode_tags;
    if (empty($shortcode_tags) || !is_array($shortcode_tags))
        return $content;
    $pattern = get_shortcode_regex();
    return preg_replace_callback( "/$pattern/s", 'do_shortcode_tag', $content );
} 
// Widget Sidebar
function fredia_widgets_init() {
  	register_sidebar( array(
      'name'          => esc_html__( 'Primary Sidebar', 'fredia' ),
      'id'            => 'sidebar-1',        
  		'description'   => esc_html__( 'Appears in the sidebar section of the site.', 'fredia' ),        
  		'before_widget' => '<div class="col-md-12 %2$s" id="%1$s"><div class="widget search">',        
  		'after_widget'  => '</div></div>',        
  		'before_title'  => '<div class="widget-title"><h6>',        
  		'after_title'   => '</h4></div>'
    ) );
    register_sidebar( array(
      'name'          => esc_html__( 'Footer One Widget', 'fredia' ),
      'id'            => 'footer-area-1',
      'description'   => esc_html__( 'Footer Widget that appears on the Footer.', 'fredia' ),
      'before_widget' => '',
      'after_widget'  => '',
      'before_title'  => ' ',
      'after_title'   => ' ',
    ) );
    register_sidebar( array(
      'name'          => esc_html__( 'Footer Two Widget', 'fredia' ),
      'id'            => 'footer-area-2',
      'description'   => esc_html__( 'Footer Widget that appears on the Footer.', 'fredia' ),
      'before_widget' => '<div id="%1$s">',
      'after_widget'  => '</div>',
      'before_title'  => ' ',
      'after_title'   => ' ',
    ) );
    register_sidebar( array(
      'name'          => esc_html__( 'Footer Three Widget', 'fredia' ),
      'id'            => 'footer-area-3',
      'description'   => esc_html__( 'Footer Widget that appears on the Footer.', 'fredia' ),
      'before_widget' => '<div id="%1$s">',
      'after_widget'  => '</div>',
      'before_title'  => ' ',
      'after_title'   => ' ',
    ) );
    register_sidebar( array(
      'name'          => esc_html__( 'Footer One Black Widget', 'fredia' ),
      'id'            => 'footer-area-4',
      'description'   => esc_html__( 'Footer Widget that appears on the Footer.', 'fredia' ),
      'before_widget' => '',
      'after_widget'  => '',
      'before_title'  => ' ',
      'after_title'   => ' ',
    ) );
    register_sidebar( array(
      'name'          => esc_html__( 'Footer Two Black Widget', 'fredia' ),
      'id'            => 'footer-area-5',
      'description'   => esc_html__( 'Footer Widget that appears on the Footer.', 'fredia' ),
      'before_widget' => '<div id="%1$s">',
      'after_widget'  => '</div>',
      'before_title'  => ' ',
      'after_title'   => ' ',
    ) );
    register_sidebar( array(
      'name'          => esc_html__( 'Footer Three Black Widget', 'fredia' ),
      'id'            => 'footer-area-6',
      'description'   => esc_html__( 'Footer Widget that appears on the Footer.', 'fredia' ),
      'before_widget' => '<div id="%1$s">',
      'after_widget'  => '</div>',
      'before_title'  => ' ',
      'after_title'   => ' ',
    ) );
    
}
add_action( 'widgets_init', 'fredia_widgets_init' );
//function tag widgets
function fredia_tag_cloud_widget($args) {
  	$args['number'] = 0; //adding a 0 will display all tags
  	$args['largest'] = 18; //largest tag
  	$args['smallest'] = 11; //smallest tag
  	$args['unit'] = 'px'; //tag font unit
  	$args['format'] = 'list'; //ul with a class of wp-tag-cloud
  	$args['exclude'] = array(20, 80, 92); //exclude tags by ID
  	return $args;
}
add_filter( 'widget_tag_cloud_args', 'fredia_tag_cloud_widget' );
function fredia_excerpt() {
  $fredia_redux_demo = get_option('redux_demo');
  if(isset($fredia_redux_demo['blog_excerpt'])){
    $limit = $fredia_redux_demo['blog_excerpt'];
  }else{
    $limit = 50;
  }
  $excerpt = explode(' ', get_the_excerpt(), $limit);
  if (count($excerpt)>=$limit) {
    array_pop($excerpt);
    $excerpt = implode(" ",$excerpt).'...';
  } else {
    $excerpt = implode(" ",$excerpt);
  }
  $excerpt = preg_replace('`[[^]]*]`','',$excerpt);
  return $excerpt;
}
function fredia_excerpt2() {
  $fredia_redux_demo = get_option('redux_demo');
  if(isset($fredia_redux_demo['services_excerpt'])){
    $limit = $fredia_redux_demo['services_excerpt'];
  }else{
    $limit = 10;
  }
  $excerpt = explode(' ', get_the_excerpt(), $limit);
  if (count($excerpt)>=$limit) {
    array_pop($excerpt);
    $excerpt = implode(" ",$excerpt).'...';
  } else {
    $excerpt = implode(" ",$excerpt);
  }
  $excerpt = preg_replace('`[[^]]*]`','',$excerpt);
  return $excerpt;
}

function fredia_search_form( $form ) {
    $form = '
        <form action="' . esc_url(home_url('/')) . '">
            <input type="text" class="s-input-home" name="s" required value="' . get_search_query() . '" placeholder="'.esc_attr__('Search…', 'fredia').'">
            <button class="btn-s-input" type="submit"><i class="ti-search" aria-hidden="true"></i></button>
        </form>
	';
    return $form;
}
add_filter( 'get_search_form', 'fredia_search_form' );
function fredia_theme_comment($comment, $args, $depth) {
    //echo 's';
   $GLOBALS['comment'] = $comment; ?>
    <?php if(get_avatar($comment,$size='100' )!=''){?>
      <div class="fredia-post-comment-wrap">
          <div class="fredia-user-comment"> <img src="<?php echo get_template_directory_uri();?>/images/blog/people.jpg" alt=""> </div>
          <div class="fredia-user-content">
              <h3><?php printf( get_comment_author_link()) ?><span> <?php the_time(get_option( 'date_format' ));?></span></h3>
              <?php comment_text() ?> 
              <a class="fredia-repay" href="#"><?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?><i class="ti-back-left"></i></a> </div>
      </div>
  <?php }else{?>
      <div class="fredia-post-comment-wrap">
          <div class="fredia-user-content">
              <h3><?php printf( get_comment_author_link()) ?><span> <?php the_time(get_option( 'date_format' ));?></span></h3>
              <?php comment_text() ?> 
              <a class="fredia-repay" href="#"><?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?><i class="ti-back-left"></i></a> </div>
      </div>
<?php }?>

<?php
}

/**
 * This file represents an example of the code that themes would use to register
 * the required plugins.
 *
 * It is expected that theme authors would copy and paste this code into their
 * functions.php file, and amend to suit.
 *
 * @package    TGM-Plugin-Activation
 * @subpackage Example
 * @version    2.6.1
 * @author     Thomas Griffin <thomasgriffinmedia.com>
 * @author     Gary Jones <gamajo.com>
 * @copyright  Copyright (c) 2014, Thomas Griffin
 * @license    http://opensource.org/licenses/gpl-2.0.php GPL v2 or later
 * @link       https://github.com/thomasgriffin/TGM-Plugin-Activation
 */
/**
 * Include the TGM_Plugin_Activation class.
 */
require_once get_template_directory() . '/framework/class-tgm-plugin-activation.php';
add_action( 'tgmpa_register', 'fredia_theme_register_required_plugins' );
/**
 * Register the required plugins for this theme.
 *
 * In this example, we register two plugins - one included with the TGMPA library
 * and one from the .org repo.
 *
 * The variable passed to tgmpa_register_plugins() should be an array of plugin
 * arrays.
 *
 * This function is hooked into tgmpa_init, which is fired within the
 * TGM_Plugin_Activation class constructor.
 */
 
 
function fredia_theme_register_required_plugins() {
    /**
     * Array of plugin arrays. Required keys are name and slug.
     * If the source is NOT from the .org repo, then source is also required.
     */
    $plugins = array(
        // This is an example of how to include a plugin from the WordPress Plugin Repository.
      
      array(
            'name'      => esc_html__( 'One Click Demo Import', 'fredia' ),
            'slug'      => 'one-click-demo-import',
            'required'  => true,
        ), 
      array(
            'name'      => esc_html__( 'Classic Editor', 'fredia' ),
            'slug'      => 'classic-editor',
            'required'  => true,
        ), 
      array(
            'name'      => esc_html__( 'Classic Widgets', 'fredia' ),
            'slug'      => 'classic-widgets',
            'required'  => true,
        ),
      array(
            'name'      => esc_html__( 'Widget Importer & Exporter', 'fredia' ),
            'slug'      => 'widget-importer-&-exporter',
            'required'  => true,
        ), 
      array(
            'name'      => esc_html__( 'Contact Form 7', 'fredia' ),
            'slug'      => 'contact-form-7',
            'required'  => true,
        ), 
      array(
            'name'      => esc_html__( 'WP Maximum Execution Time Exceeded', 'fredia' ),
            'slug'      => 'wp-maximum-execution-time-exceeded',
            'required'  => true,
        ), 
      array(
            'name'                     => esc_html__( 'Elementor', 'fredia' ),
            'slug'                     => 'elementor',
            'required'                 => true,
            'source'                   => get_template_directory() . '/framework/plugins/elementor.zip',
        ),
      array(
            'name'                     => esc_html__( 'Fredia Common', 'fredia' ),
            'slug'                     => 'fredia-common',
            'required'                 => true,
            'source'                   => get_template_directory() . '/framework/plugins/fredia-common.zip',
        ),
      array(
            'name'                     => esc_html__( 'Fredia Elementor', 'fredia' ),
            'slug'                     => 'fredia-elementor',
            'required'                 => true,
            'source'                   => get_template_directory() . '/framework/plugins/fredia-elementor.zip',
        ),

    );
    /**
     * Array of configuration settings. Amend each line as needed.
     * If you want the default strings to be available under your own theme domain,
     * leave the strings uncommented.
     * Some of the strings are added into a sprintf, so see the comments at the
     * end of each line for what each argument will be.
     */
    $config = array(
        'default_path' => '',                      // Default absolute path to pre-packaged plugins.
        'menu'         => 'tgmpa-install-plugins', // Menu slug.
        'has_notices'  => true,                    // Show admin notices or not.
        'dismissable'  => true,                    // If false, a user cannot dismiss the nag message.
        'dismiss_msg'  => '',                      // If 'dismissable' is false, this message will be output at top of nag.
        'is_automatic' => false,                   // Automatically activate plugins after installation or not.
        'message'      => '',                      // Message to output right before the plugins table.
        'strings'      => array(
            'page_title'                      => esc_html__( 'Install Required Plugins', 'fredia' ),
            'menu_title'                      => esc_html__( 'Install Plugins', 'fredia' ),
            'installing'                      => esc_html__( 'Installing Plugin: %s', 'fredia' ), // %s = plugin name.
            'oops'                            => esc_html__( 'Something went wrong with the plugin API.', 'fredia' ),
            'notice_can_install_required'     => _n_noop( 'This theme requires the following plugin: %1$s.', 'This theme requires the following plugins: %1$s.', 'fredia' ), // %1$s = plugin name(s).
            'notice_can_install_recommended'  => _n_noop( 'This theme recommends the following plugin: %1$s.', 'This theme recommends the following plugins: %1$s.', 'fredia' ), // %1$s = plugin name(s).
            'notice_cannot_install'           => _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.', 'fredia' ), // %1$s = plugin name(s).
            'notice_can_activate_required'    => _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.', 'fredia' ), // %1$s = plugin name(s).
            'notice_can_activate_recommended' => _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.', 'fredia' ), // %1$s = plugin name(s).
            'notice_cannot_activate'          => _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.', 'fredia' ), // %1$s = plugin name(s).
            'notice_ask_to_update'            => _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.', 'fredia' ), // %1$s = plugin name(s).
            'notice_cannot_update'            => _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.', 'fredia' ), // %1$s = plugin name(s).
            'install_link'                    => _n_noop( 'Begin installing plugin', 'Begin installing plugins', 'fredia' ),
            'activate_link'                   => _n_noop( 'Begin activating plugin', 'Begin activating plugins', 'fredia' ),
            'return'                          => esc_html__( 'Return to Required Plugins Installer', 'fredia' ),
            'plugin_activated'                => esc_html__( 'Plugin activated successfully.', 'fredia' ),
            'complete'                        => esc_html__( 'All plugins installed and activated successfully. %s', 'fredia' ), // %s = dashboard link.
            'nag_type'                        => 'updated' // Determines admin notice type - can only be 'updated', 'update-nag' or 'error'.
        )
    );
    tgmpa( $plugins, $config );
}
?>