<!doctype html>
<html <?php language_attributes(); ?>>
<?php $fredia_redux_demo = get_option('redux_demo'); ?>
<head>
    <meta charset="<?php bloginfo( 'charset' ); ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?php if ( ! function_exists( 'has_site_icon' ) || ! has_site_icon() ) {
        ?>
    <link rel="shortcut icon" href="<?php if(isset($fredia_redux_demo['favicon']['url'])){?><?php echo esc_url($fredia_redux_demo['favicon']['url']); ?><?php }?>">
    <?php }?>
    <?php wp_head(); ?> 
</head>
<body <?php body_class(); ?>>
<!--[if lt IE 8]>
<p class="browserupgrade">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade your browser</a> to improve your experience.</p>
<![endif]-->
<!-- < NAVIGATION WITH BACKGROUND COLOR NAVBAR >............................................ -->
<!-- removed navbar-toggleable-md because responsive issues. Find out why ..... -->
<!-- start page-wrapper -->
<div id="fredia-page-loading" class="fredia-pageloading">
    <div class="fredia-pageloading-inner">
        <a class="fredia-pageloading" href="<?php echo esc_url(home_url('/')); ?>"> <img src="<?php echo esc_url($fredia_redux_demo['logo']['url']); ?>" alt=" "> </a>
    </div>
</div>
<!-- Header -->
<header>
    <div class="fredia-header-navbar">
        <div class="container fredia-navbar-container">
            <div class="fredia-navigation-wrap fredia-start-header start-style">
                <div class="container">
                    <div class="row">
                        <div class="col-md-12">
                            <nav class="navbar navbar-expand-md navbar-light">
                                <!-- Logo -->
                                <?php if(isset($fredia_redux_demo['logo']['url']) && $fredia_redux_demo['logo']['url'] != ''){?> 
                                <a class="navbar-brand" href="<?php echo esc_url(home_url('/')); ?>"> <img src="<?php echo esc_url($fredia_redux_demo['logo']['url']); ?>" alt=""> </a>
                                <?php }else{?>
                                <a class="navbar-brand" href="<?php echo esc_url(home_url('/')); ?>"> <img src="<?php echo get_template_directory_uri();?>/images/logo.png" alt=""> </a>
                                <?php } ?> 
                                <!-- Menu -->
                                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation"> <span class="navbar-toggler-icon"></span> </button>
                                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                                    <?php 
                                    wp_nav_menu( 
                                        array( 
                                            'theme_location' => 'primary',
                                            'container' => '',
                                            'menu_class' => '', 
                                            'menu_id' => '',
                                            'menu'            => '',
                                            'container_class' => '',
                                            'container_id'    => '',
                                            'echo'            => true,
                                             'fallback_cb'       => 'wp_bootstrap_navwalker::fallback',
                                             'walker'            => new fredia_wp_bootstrap_navwalker(),
                                            'before'          => '',
                                            'after'           => '',
                                            'link_before'     => '',
                                            'link_after'      => '',
                                            'items_wrap'      => '<ul class=" navbar-nav ml-auto py-4 py-md-0 %2$s" >%3$s</ul>',
                                            'depth'           => 0,        
                                        )
                                    ); ?>
                                </div>
                            </nav>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</header>